# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.12
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
if _swig_python_version_info >= (2, 7, 0):
    def swig_import_helper():
        import importlib
        pkg = __name__.rpartition('.')[0]
        mname = '.'.join((pkg, '_densityfield')).lstrip('.')
        try:
            return importlib.import_module(mname)
        except ImportError:
            return importlib.import_module('_densityfield')
    _densityfield = swig_import_helper()
    del swig_import_helper
elif _swig_python_version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_densityfield', [dirname(__file__)])
        except ImportError:
            import _densityfield
            return _densityfield
        try:
            _mod = imp.load_module('_densityfield', fp, pathname, description)
        finally:
            if fp is not None:
                fp.close()
        return _mod
    _densityfield = swig_import_helper()
    del swig_import_helper
else:
    import _densityfield
del _swig_python_version_info

try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr(self, class_type, name):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    raise AttributeError("'%s' object has no attribute '%s'" % (class_type.__name__, name))


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except __builtin__.Exception:
    class _object:
        pass
    _newclass = 0

class SwigPyIterator(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _densityfield.delete_SwigPyIterator
    __del__ = lambda self: None

    def value(self) -> "PyObject *":
        return _densityfield.SwigPyIterator_value(self)

    def incr(self, n: 'size_t'=1) -> "swig::SwigPyIterator *":
        return _densityfield.SwigPyIterator_incr(self, n)

    def decr(self, n: 'size_t'=1) -> "swig::SwigPyIterator *":
        return _densityfield.SwigPyIterator_decr(self, n)

    def distance(self, x: 'SwigPyIterator') -> "ptrdiff_t":
        return _densityfield.SwigPyIterator_distance(self, x)

    def equal(self, x: 'SwigPyIterator') -> "bool":
        return _densityfield.SwigPyIterator_equal(self, x)

    def copy(self) -> "swig::SwigPyIterator *":
        return _densityfield.SwigPyIterator_copy(self)

    def next(self) -> "PyObject *":
        return _densityfield.SwigPyIterator_next(self)

    def __next__(self) -> "PyObject *":
        return _densityfield.SwigPyIterator___next__(self)

    def previous(self) -> "PyObject *":
        return _densityfield.SwigPyIterator_previous(self)

    def advance(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator *":
        return _densityfield.SwigPyIterator_advance(self, n)

    def __eq__(self, x: 'SwigPyIterator') -> "bool":
        return _densityfield.SwigPyIterator___eq__(self, x)

    def __ne__(self, x: 'SwigPyIterator') -> "bool":
        return _densityfield.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator &":
        return _densityfield.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator &":
        return _densityfield.SwigPyIterator___isub__(self, n)

    def __add__(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator *":
        return _densityfield.SwigPyIterator___add__(self, n)

    def __sub__(self, *args) -> "ptrdiff_t":
        return _densityfield.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self
SwigPyIterator_swigregister = _densityfield.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

SHARED_PTR_DISOWN = _densityfield.SHARED_PTR_DISOWN
import CosmoBolognaLib
InterpolationScheme__NGP_ = _densityfield.InterpolationScheme__NGP_
InterpolationScheme__CIC_ = _densityfield.InterpolationScheme__CIC_

def InterpolationSchemeNames() -> "std::vector< std::string,std::allocator< std::string > >":
    return _densityfield.InterpolationSchemeNames()
InterpolationSchemeNames = _densityfield.InterpolationSchemeNames

def InterpolationSchemeCast(*args) -> "std::vector< cbl::data::InterpolationScheme,std::allocator< cbl::data::InterpolationScheme > >":
    return _densityfield.InterpolationSchemeCast(*args)
InterpolationSchemeCast = _densityfield.InterpolationSchemeCast
class DensityContrastField(CosmoBolognaLib.ScalarField3D):
    __swig_setmethods__ = {}
    for _s in [CosmoBolognaLib.ScalarField3D]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DensityContrastField, name, value)
    __swig_getmethods__ = {}
    for _s in [CosmoBolognaLib.ScalarField3D]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, DensityContrastField, name)
    __repr__ = _swig_repr
    __swig_destroy__ = _densityfield.delete_DensityContrastField
    __del__ = lambda self: None

    def __init__(self, *args):
        this = _densityfield.new_DensityContrastField(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def set_catalogue(self, *args) -> "void":
        return _densityfield.DensityContrastField_set_catalogue(self, *args)
DensityContrastField_swigregister = _densityfield.DensityContrastField_swigregister
DensityContrastField_swigregister(DensityContrastField)

# This file is compatible with both classic and new-style classes.


